function YYpred_means = transform_YY_means(YYpred, ny)
% Takes a data matrix with columns
%  [Y_{1,t},Y_{1,t+1},...,Y_{ny,t},Y_{ny,t+1}]
%  and transforms it into one with cumulative means

% information
ntraj = size(YYpred,1);
hmax  = size(YYpred,2)/ny;

denomi       = ones(ntraj,1)*(1:1:hmax);
YYpred_means = zeros(size(YYpred));

for indx_y = 1:1:ny
    
    temp_YY   = YYpred(:, (indx_y-1)*hmax+1:indx_y*hmax);
    cm_tempYY = cumsum(temp_YY,2)./denomi;
    YYpred_means(:,(indx_y-1)*hmax+1:indx_y*hmax) ...
              = cm_tempYY;

end