function nega_post = objfcn_pm_sbsv(trspara, trspec, prior, estinfo, YY, modelname, order_app, n_particle, T0_)
% objective function for dsge_pm.m
% [1] Entered para is transformed one (defined on [-inf, inf])
% [2] Control fixed parameters

% recover prior information
pshape   = prior(:,1);
pmean    = prior(:,2);
pstdd    = prior(:,3);
pmask    = prior(:,4);
pfix     = prior(:,5);
pmaskinv = 1 - pmask;
pshape   = pshape.*pmaskinv;

% 
modelpara = trans(trspara, trspec); %transform back to the original values
modelpara = modelpara.*pmaskinv + pfix.*pmask;

% evaluation of likelihood
if order_app == 1 && n_particle == 0
    
    [loglik, s_up, error] = evalmod_kalman_gensys_sbsv(modelpara, [], YY, estinfo, modelname);
    Xhat = s_up;
    Yhat = [];
    lnpY = sum(loglik(T0_:end,:));

else
    disp('objfcn_pm: order&#particle are not defined');
end

% error control
if isempty(lnpY)
    %lnpY = -inf;
    %lnprior = -inf;
    nega_post = inf;
    return
end

if error ~= 0
    
    disp('error in pm: stopped');
    error
%     pause
    %lnpY = -inf;
    %lnprior = -inf;
    nega_post = inf;
    return
end

% evaluate the prior distribution
lnprio = priodens(modelpara, pmean, pstdd, pshape);

% minimize the negative log posterior
nega_post = (-lnpY -lnprio);

% format long g
% -nega_post
% modelpara(1)
% pause










