function KH = mksdensity(XX,xx,cc)
% multivariate KS density
% XX: data (xdim by nobs)
% xx: point where we want to evaluate (xdim by 1)
% remark
% cc = (4/(2*nv_+1))^(1/(nv_+4)); %silverman's optimal bandwidth under gaussian see Pagan and Ullah
% example
% mksdensity(randn(100,2)', [-1,0]')
% XX = randn(50000,2)';
% xx = [-5,0]';

% parameter for bandwidth
c = cc;

% size
[d, nobs] = size(XX);

if d>nobs
    disp('check dimension for XX and xx');
    KH = nan;
end

% bandwidth
hh = c*nobs^(-1/(4+d));
HH = hh^2*eye(d);

% Kernel Estimates
const = 1/nobs*1/(hh^d);
KH = const*sum(mvnpdf( (HH^(-1/2)*(XX- repmat(xx,1,nobs)))' ));
